<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <title>Document</title>
  <script src="https://unpkg.com/vue"></script>
</head>

<body>
  <div id="app">
    <!--
      - no vue, sempre que uma lista é modificada, a renderização é atualizada
      - p/ o vue, não é simples monitorar mudanças na lista, pois ela é uma ref em memória
      - p/ fzr o acompanhamento (tracking), o vue faz uma implementação via proxy ('remendo local'), tornando-se bem custosa
      - em situações de mudança de lista
        - como:
          - mudança de ordem dos itens
          - adição de novos elementos
        - é importante fornecer ao Vue uma dica (hint), de como cada elemento se relaciona com a lista (como são definidos na lista), através da indicação de qual é a identidade de cada um desses elementos
        - vide:
          - https://vuejs.org/v2/guide/list.html#Array-Change-Detection
          - https://vuejs.org/v2/guide/list.html#Maintaining-State
        - fazer bind de um atributo key, em listas mais complexas, ajuda o vue a:
          - monitorar mudanças
          - renderizar os itens atualizados
          - reordenar itens
          - adicionar itens
        - não é interessante usar, como key, índice autogerado.
        - o ideal é usar atributo do próprio objeto.
        - por isso que é importante ter propriedade no objeto p/ um ID único (quando é detectada key duplicada, o vue lança um alerta)
        - em listas simples, ou objetos sem campo de ID, pode ser que o campo usado como key se repita
    -->
    <button @click="cores.push('branco')">Add 'branco'</button>
    <ul>
      <li v-for="cor in cores" :key="cor">
        {{ cor }}
      </li>
    </ul>
  </div>
  <script src="app.js"></script>
</body>

</html>